import { useAbly } from './useAbly.js';
import { useEventListener } from './useEventListener.js';
export function useChannelStateListener(channelNameOrNameAndId, stateOrListener, listener) {
    const channelName = typeof channelNameOrNameAndId === 'string'
        ? channelNameOrNameAndId
        : channelNameOrNameAndId.channelName;
    const id = channelNameOrNameAndId === null || channelNameOrNameAndId === void 0 ? void 0 : channelNameOrNameAndId.id;
    const ably = useAbly(id);
    const channel = ably.channels.get(channelName);
    const _listener = typeof listener === 'function'
        ? listener
        : stateOrListener;
    const state = typeof stateOrListener !== 'function' ? stateOrListener : undefined;
    useEventListener(channel, _listener, state);
}
//# sourceMappingURL=useChannelStateListener.js.map