"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useChannelStateListener = void 0;
const useAbly_js_1 = require("./useAbly.js");
const useEventListener_js_1 = require("./useEventListener.js");
function useChannelStateListener(channelNameOrNameAndId, stateOrListener, listener) {
    const channelName = typeof channelNameOrNameAndId === 'string' ? channelNameOrNameAndId : channelNameOrNameAndId.channelName;
    const id = channelNameOrNameAndId === null || channelNameOrNameAndId === void 0 ? void 0 : channelNameOrNameAndId.id;
    const ably = (0, useAbly_js_1.useAbly)(id);
    const channel = ably.channels.get(channelName);
    const _listener = typeof listener === 'function' ? listener : stateOrListener;
    const state = typeof stateOrListener !== 'function' ? stateOrListener : undefined;
    (0, useEventListener_js_1.useEventListener)(channel, _listener, state);
}
exports.useChannelStateListener = useChannelStateListener;
//# sourceMappingURL=useChannelStateListener.js.map